#!python
import argparse,subprocess
parser = argparse.ArgumentParser(description='Use -i to specify *.fastq.gz | *.fq.gz | *.fq |*.fastq')


parser.add_argument('-i', '--input', dest='fastqfile', action='store',
					help='Input FASTQ file path. e.g. python name10x.py -i /data/sample1_R1.fastq.gz',required=True)

args = parser.parse_args()


indexSetJson="""[
    [
        "SI-GA-A1", 
        [
            "GGTTTACT", 
            "CTAAACGG", 
            "TCGGCGTC", 
            "AACCGTAA"
        ]
    ], 
    [
        "SI-GA-A2", 
        [
            "TTTCATGA", 
            "ACGTCCCT", 
            "CGCATGTG", 
            "GAAGGAAC"
        ]
    ], 
    [
        "SI-GA-A3", 
        [
            "CAGTACTG", 
            "AGTAGTCT", 
            "GCAGTAGA", 
            "TTCCCGAC"
        ]
    ], 
    [
        "SI-GA-A4", 
        [
            "TATGATTC", 
            "CCCACAGT", 
            "ATGCTGAA", 
            "GGATGCCG"
        ]
    ], 
    [
        "SI-GA-A5", 
        [
            "CTAGGTGA", 
            "TCGTTCAG", 
            "AGCCAATT", 
            "GATACGCC"
        ]
    ], 
    [
        "SI-GA-A6", 
        [
            "CGCTATGT", 
            "GCTGTCCA", 
            "TTGAGATC", 
            "AAACCGAG"
        ]
    ], 
    [
        "SI-GA-A7", 
        [
            "ACAGAGGT", 
            "TATAGTTG", 
            "CGGTCCCA", 
            "GTCCTAAC"
        ]
    ], 
    [
        "SI-GA-A8", 
        [
            "GCATCTCC", 
            "TGTAAGGT", 
            "CTGCGATG", 
            "AACGTCAA"
        ]
    ], 
    [
        "SI-GA-A9", 
        [
            "TCTTAAAG", 
            "CGAGGCTC", 
            "GTCCTTCT", 
            "AAGACGGA"
        ]
    ], 
    [
        "SI-GA-A10", 
        [
            "GAAACCCT", 
            "TTTCTGTC", 
            "CCGTGTGA", 
            "AGCGAAAG"
        ]
    ], 
    [
        "SI-GA-A11", 
        [
            "GTCCGGTC", 
            "AAGATCAT", 
            "CCTGAAGG", 
            "TGATCTCA"
        ]
    ], 
    [
        "SI-GA-A12", 
        [
            "AGTGGAAC", 
            "GTCTCCTT", 
            "TCACATCA", 
            "CAGATGGG"
        ]
    ], 
    [
        "SI-GA-B1", 
        [
            "GTAATCTT", 
            "TCCGGAAG", 
            "AGTTCGGC", 
            "CAGCATCA"
        ]
    ], 
    [
        "SI-GA-B2", 
        [
            "TACTCTTC", 
            "CCTGTGCG", 
            "GGACACGT", 
            "ATGAGAAA"
        ]
    ], 
    [
        "SI-GA-B3", 
        [
            "GTGTATTA", 
            "TGTGCGGG", 
            "ACCATAAC", 
            "CAACGCCT"
        ]
    ], 
    [
        "SI-GA-B4", 
        [
            "ACTTCATA", 
            "GAGATGAC", 
            "TGCCGTGG", 
            "CTAGACCT"
        ]
    ], 
    [
        "SI-GA-B5", 
        [
            "AATAATGG", 
            "CCAGGGCA", 
            "TGCCTCAT", 
            "GTGTCATC"
        ]
    ], 
    [
        "SI-GA-B6", 
        [
            "CGTTAATC", 
            "GCCACGCT", 
            "TTACTCAG", 
            "AAGGGTGA"
        ]
    ], 
    [
        "SI-GA-B7", 
        [
            "AAACCTCA", 
            "GCCTTGGT", 
            "CTGGACTC", 
            "TGTAGAAG"
        ]
    ], 
    [
        "SI-GA-B8", 
        [
            "AAAGTGCT", 
            "GCTACCTG", 
            "TGCTGTAA", 
            "CTGCAAGC"
        ]
    ], 
    [
        "SI-GA-B9", 
        [
            "CTGTAACT", 
            "TCTAGCGA", 
            "AGAGTGTG", 
            "GACCCTAC"
        ]
    ], 
    [
        "SI-GA-B10", 
        [
            "ACCGTATG", 
            "GATTAGAT", 
            "CTGACTGA", 
            "TGACGCCC"
        ]
    ], 
    [
        "SI-GA-B11", 
        [
            "GTTCCTCA", 
            "AGGTACGC", 
            "TAAGTATG", 
            "CCCAGGAT"
        ]
    ], 
    [
        "SI-GA-B12", 
        [
            "TACCACCA", 
            "CTAAGTTT", 
            "GGGTCAAG", 
            "ACTGTGGC"
        ]
    ], 
    [
        "SI-GA-C1", 
        [
            "CCACTTAT", 
            "AACTGGCG", 
            "TTGGCATA", 
            "GGTAACGC"
        ]
    ], 
    [
        "SI-GA-C2", 
        [
            "CCTAGACC", 
            "ATCTCTGT", 
            "TAGCTCTA", 
            "GGAGAGAG"
        ]
    ], 
    [
        "SI-GA-C3", 
        [
            "TCAGCCGT", 
            "CAGAGGCC", 
            "GGTCAATA", 
            "ATCTTTAG"
        ]
    ], 
    [
        "SI-GA-C4", 
        [
            "ACAATTCA", 
            "TGCGCAGC", 
            "CATCACTT", 
            "GTGTGGAG"
        ]
    ], 
    [
        "SI-GA-C5", 
        [
            "CGACTTGA", 
            "TACAGACT", 
            "ATTGCGTG", 
            "GCGTACAC"
        ]
    ], 
    [
        "SI-GA-C6", 
        [
            "ATTACTTC", 
            "TGCGAACT", 
            "GCATTCGG", 
            "CAGCGGAA"
        ]
    ], 
    [
        "SI-GA-C7", 
        [
            "GTCTCTCG", 
            "AATCTCTC", 
            "CGGAGGGA", 
            "TCAGAAAT"
        ]
    ], 
    [
        "SI-GA-C8", 
        [
            "GTTGAGAA", 
            "AGATCTGG", 
            "TCGATACT", 
            "CACCGCTC"
        ]
    ], 
    [
        "SI-GA-C9", 
        [
            "GCGCAGAA", 
            "ATCTTACC", 
            "TATGGTGT", 
            "CGAACCTG"
        ]
    ], 
    [
        "SI-GA-C10", 
        [
            "TCTCAGTG", 
            "GAGACTAT", 
            "CGCTTAGC", 
            "ATAGGCCA"
        ]
    ], 
    [
        "SI-GA-C11", 
        [
            "GAGGATCT", 
            "AGACCATA", 
            "TCCTGCGC", 
            "CTTATGAG"
        ]
    ], 
    [
        "SI-GA-C12", 
        [
            "TCTCGTTT", 
            "GGCTAGCG", 
            "ATGACCGC", 
            "CAAGTAAA"
        ]
    ], 
    [
        "SI-GA-D1", 
        [
            "CACTCGGA", 
            "GCTGAATT", 
            "TGAAGTAC", 
            "ATGCTCCG"
        ]
    ], 
    [
        "SI-GA-D2", 
        [
            "TAACAAGG", 
            "GGTTCCTC", 
            "ATCATGCA", 
            "CCGGGTAT"
        ]
    ], 
    [
        "SI-GA-D3", 
        [
            "ACATTACT", 
            "TTTGGGTA", 
            "CAGCCCAC", 
            "GGCAATGG"
        ]
    ], 
    [
        "SI-GA-D4", 
        [
            "CCCTAACA", 
            "ATTCCGAT", 
            "TGGATTGC", 
            "GAAGGCTG"
        ]
    ], 
    [
        "SI-GA-D5", 
        [
            "CTCGTCAC", 
            "GATCAGCA", 
            "ACAACAGG", 
            "TGGTGTTT"
        ]
    ], 
    [
        "SI-GA-D6", 
        [
            "CATGCGAT", 
            "TGATATTC", 
            "GTGATCGA", 
            "ACCCGACG"
        ]
    ], 
    [
        "SI-GA-D7", 
        [
            "ATTTGCTA", 
            "TAGACACC", 
            "CCACAGGG", 
            "GGCGTTAT"
        ]
    ], 
    [
        "SI-GA-D8", 
        [
            "GCAACAAA", 
            "TAGTTGTC", 
            "CGCCATCG", 
            "ATTGGCGT"
        ]
    ], 
    [
        "SI-GA-D9", 
        [
            "AGGAGATG", 
            "GATGTGGT", 
            "CTACATCC", 
            "TCCTCCAA"
        ]
    ], 
    [
        "SI-GA-D10", 
        [
            "CAATACCC", 
            "TGTCTATG", 
            "ACCACGAA", 
            "GTGGGTGT"
        ]
    ], 
    [
        "SI-GA-D11", 
        [
            "CTTTGCGG", 
            "TGCACAAA", 
            "AAGCAGTC", 
            "GCAGTTCT"
        ]
    ], 
    [
        "SI-GA-D12", 
        [
            "GCACAATG", 
            "CTTGGTAC", 
            "TGCACCGT", 
            "AAGTTGCA"
        ]
    ], 
    [
        "SI-GA-E1", 
        [
            "TGGTAAAC", 
            "GAAAGGGT", 
            "ACTGCTCG", 
            "CTCCTCTA"
        ]
    ], 
    [
        "SI-GA-E2", 
        [
            "GTGGTACC", 
            "TACTATAG", 
            "ACAAGGTA", 
            "CGTCCCGT"
        ]
    ], 
    [
        "SI-GA-E3", 
        [
            "AGGTATTG", 
            "CTCCTAGT", 
            "TCAAGGCC", 
            "GATGCCAA"
        ]
    ], 
    [
        "SI-GA-E4", 
        [
            "TTCGCCCT", 
            "GGATGGGC", 
            "AATCAATG", 
            "CCGATTAA"
        ]
    ], 
    [
        "SI-GA-E5", 
        [
            "CATTAGCG", 
            "TTCGCTGA", 
            "ACAAGAAT", 
            "GGGCTCTC"
        ]
    ], 
    [
        "SI-GA-E6", 
        [
            "CTGCGGCT", 
            "GACTCAAA", 
            "AGAAACTC", 
            "TCTGTTGG"
        ]
    ], 
    [
        "SI-GA-E7", 
        [
            "CACGCCTT", 
            "GTATATAG", 
            "TCTCGGGC", 
            "AGGATACA"
        ]
    ], 
    [
        "SI-GA-E8", 
        [
            "ATAGTTAC", 
            "TGCTGAGT", 
            "CCTACGTA", 
            "GAGCACCG"
        ]
    ], 
    [
        "SI-GA-E9", 
        [
            "TTGTTTCC", 
            "GGAGGAGG", 
            "CCTAACAA", 
            "AACCCGTT"
        ]
    ], 
    [
        "SI-GA-E10", 
        [
            "AAATGTGC", 
            "GGGCAAAT", 
            "TCTATCCG", 
            "CTCGCGTA"
        ]
    ], 
    [
        "SI-GA-E11", 
        [
            "AAGCGCTG", 
            "CGTTTGAT", 
            "GTAGCACA", 
            "TCCAATGC"
        ]
    ], 
    [
        "SI-GA-E12", 
        [
            "ACCGGCTC", 
            "GAGTTAGT", 
            "CGTCCTAG", 
            "TTAAAGCA"
        ]
    ], 
    [
        "SI-GA-F1", 
        [
            "GTTGCAGC", 
            "TGGAATTA", 
            "CAATGGAG", 
            "ACCCTCCT"
        ]
    ], 
    [
        "SI-GA-F2", 
        [
            "TTTACATG", 
            "CGCGATAC", 
            "ACGCGGGT", 
            "GAATTCCA"
        ]
    ], 
    [
        "SI-GA-F3", 
        [
            "TTCAGGTG", 
            "ACGGACAT", 
            "GATCTTGA", 
            "CGATCACC"
        ]
    ], 
    [
        "SI-GA-F4", 
        [
            "CCCAATAG", 
            "GTGTCGCT", 
            "AGAGTCGC", 
            "TATCGATA"
        ]
    ], 
    [
        "SI-GA-F5", 
        [
            "GACTACGT", 
            "CTAGCGAG", 
            "TCTATATC", 
            "AGGCGTCA"
        ]
    ], 
    [
        "SI-GA-F6", 
        [
            "CGGAGCAC", 
            "GACCTATT", 
            "ACTTAGGA", 
            "TTAGCTCG"
        ]
    ], 
    [
        "SI-GA-F7", 
        [
            "CGTGCAGA", 
            "AACAAGAT", 
            "TCGCTTCG", 
            "GTATGCTC"
        ]
    ], 
    [
        "SI-GA-F8", 
        [
            "CATGAACA", 
            "TCACTCGC", 
            "AGCTGGAT", 
            "GTGACTTG"
        ]
    ], 
    [
        "SI-GA-F9", 
        [
            "CAAGCTCC", 
            "GTTCACTG", 
            "TCGTGAAA", 
            "AGCATGGT"
        ]
    ], 
    [
        "SI-GA-F10", 
        [
            "GCTTGGCT", 
            "AAACAAAC", 
            "CGGGCTTA", 
            "TTCATCGG"
        ]
    ], 
    [
        "SI-GA-F11", 
        [
            "GCGAGAGT", 
            "TACGTTCA", 
            "AGTCCCAC", 
            "CTATAGTG"
        ]
    ], 
    [
        "SI-GA-F12", 
        [
            "TGATGCAT", 
            "GCTACTGA", 
            "CACCTGCC", 
            "ATGGAATG"
        ]
    ], 
    [
        "SI-GA-G1", 
        [
            "ATGAATCT", 
            "GATCTCAG", 
            "CCAGGAGC", 
            "TGCTCGTA"
        ]
    ], 
    [
        "SI-GA-G2", 
        [
            "TGATTCTA", 
            "ACTAGGAG", 
            "CAGCCACT", 
            "GTCGATGC"
        ]
    ], 
    [
        "SI-GA-G3", 
        [
            "CCTCATTC", 
            "AGCATCCG", 
            "GTGGCAAT", 
            "TAATGGGA"
        ]
    ], 
    [
        "SI-GA-G4", 
        [
            "GCGATGTG", 
            "AGATACAA", 
            "TTTCCACT", 
            "CACGGTGC"
        ]
    ], 
    [
        "SI-GA-G5", 
        [
            "GAGCAAGA", 
            "TCTGTGAT", 
            "CGCAGTTC", 
            "ATATCCCG"
        ]
    ], 
    [
        "SI-GA-G6", 
        [
            "CTGACGCG", 
            "GGTCGTAC", 
            "TCCTTCTT", 
            "AAAGAAGA"
        ]
    ], 
    [
        "SI-GA-G7", 
        [
            "GGTATGCA", 
            "CTCGAAAT", 
            "ACACCTTC", 
            "TAGTGCGG"
        ]
    ], 
    [
        "SI-GA-G8", 
        [
            "TATGAGCT", 
            "CCGATAGC", 
            "ATACCCAA", 
            "GGCTGTTG"
        ]
    ], 
    [
        "SI-GA-G9", 
        [
            "TAGGACGT", 
            "ATCCCACA", 
            "GGAATGTC", 
            "CCTTGTAG"
        ]
    ], 
    [
        "SI-GA-G10", 
        [
            "TCGCCAGC", 
            "AATGTTAG", 
            "CGATAGCT", 
            "GTCAGCTA"
        ]
    ], 
    [
        "SI-GA-G11", 
        [
            "TTATCGTT", 
            "AGCAGAGC", 
            "CATCTCCA", 
            "GCGGATAG"
        ]
    ], 
    [
        "SI-GA-G12", 
        [
            "ATTCTAAG", 
            "CCCGATTA", 
            "TGGAGGCT", 
            "GAATCCGC"
        ]
    ], 
    [
        "SI-GA-H1", 
        [
            "GTATGTCA", 
            "TGTCAGAC", 
            "CACGTCGG", 
            "ACGACATT"
        ]
    ], 
    [
        "SI-GA-H2", 
        [
            "TAATGACC", 
            "ATGCCTTA", 
            "GCCGAGAT", 
            "CGTATCGG"
        ]
    ], 
    [
        "SI-GA-H3", 
        [
            "CCAAGATG", 
            "AGGCCCGA", 
            "TACGTGAC", 
            "GTTTATCT"
        ]
    ], 
    [
        "SI-GA-H4", 
        [
            "GCCATTCC", 
            "CAAGAATT", 
            "TTGCCGGA", 
            "AGTTGCAG"
        ]
    ], 
    [
        "SI-GA-H5", 
        [
            "CCACTACA", 
            "GATTCTGG", 
            "TGCGGCTT", 
            "ATGAAGAC"
        ]
    ], 
    [
        "SI-GA-H6", 
        [
            "TAGGATAA", 
            "CCTTTGTC", 
            "GTACGCGG", 
            "AGCACACT"
        ]
    ], 
    [
        "SI-GA-H7", 
        [
            "AGCTATCA", 
            "CATATAAC", 
            "TCAGGGTG", 
            "GTGCCCGT"
        ]
    ], 
    [
        "SI-GA-H8", 
        [
            "TTGTTGAT", 
            "GCTCAACC", 
            "CAAAGTGG", 
            "AGCGCCTA"
        ]
    ], 
    [
        "SI-GA-H9", 
        [
            "ACACTGTT", 
            "CAGGATGG", 
            "GGCTGAAC", 
            "TTTACCCA"
        ]
    ], 
    [
        "SI-GA-H10", 
        [
            "GTAATTGC", 
            "AGTCGCTT", 
            "CACGAGAA", 
            "TCGTCACG"
        ]
    ], 
    [
        "SI-GA-H11", 
        [
            "GGCGAGTA", 
            "ACTTCTAT", 
            "CAAATACG", 
            "TTGCGCGC"
        ]
    ], 
    [
        "SI-GA-H12", 
        [
            "GACAGCAT", 
            "TTTGTACA", 
            "AGGCCGTG", 
            "CCATATGC"
        ]
    ]
]"""
import json
indexSet=json.loads(indexSetJson)
dictionary= dict()
for design in indexSet:
    setName=design[0]
    index0,index1,index2,index3 = design[1][0],design[1][1],design[1][2],design[1][3]
    dictionary[index0]=setName+"_1"
    dictionary[index1]=setName+"_2"
    dictionary[index2]=setName+"_3"
    dictionary[index3]=setName+"_4"


fastqpath= args.fastqfile

import os
cmd=os.path.join("zgrep ^@  %s | head -1 | rev| cut -d \":\" -f1 |rev"%
                 fastqpath)
sampleIndex=subprocess.getstatusoutput(cmd)[1]

idxName= dictionary[sampleIndex]
idxNum = idxName.split("_")[1]
print("IndexSet:\t",idxName)
print("Read1:\t",idxName+"_S%s"%idxNum+"_L001_R1_001.fastq.gz")
print("Read2:\t",idxName+"_S%s"%idxNum+"_L001_R2_001.fastq.gz")
